﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports System.Windows.Navigation
Imports SudukoArticle.ViewModels

Namespace SudukoArticle
	Partial Public Class MainPage
		Inherits PhoneApplicationPage
		' Constructor
		Public Sub New()
			InitializeComponent()
			SupportedOrientations = SupportedPageOrientation.Portrait Or SupportedPageOrientation.Landscape
			AddHandler InputControl.SendInput, AddressOf InputControl_SendInput
		End Sub

		Private Sub InputControl_SendInput(ByVal sender As Object, ByVal e As EventArgs)
            MainBoard.GameBoard.SendInput(Integer.Parse(sender.ToString()))
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
            Dim board = GameBoardViewModel.LoadFromDisk()
			If board Is Nothing Then
				board = GameBoardViewModel.LoadNewPuzzle()
			End If

			MainBoard.GameBoard = board
			MyBase.OnNavigatedTo(e)
		End Sub

		Protected Overrides Sub OnNavigatedFrom(ByVal e As NavigationEventArgs)
			MainBoard.GameBoard.SaveToDisk()
			MyBase.OnNavigatedFrom(e)
		End Sub

		Protected Overrides Sub OnOrientationChanged(ByVal e As OrientationChangedEventArgs)
			Select Case e.Orientation
				Case PageOrientation.Landscape, PageOrientation.LandscapeLeft, PageOrientation.LandscapeRight
					TitlePanel.Visibility = Visibility.Collapsed
					Grid.SetColumn(InputControl, 1)
					Grid.SetRow(InputControl, 0)
					InputControl.RotateVertical()
				Case PageOrientation.Portrait, PageOrientation.PortraitUp, PageOrientation.PortraitDown
					TitlePanel.Visibility = Visibility.Visible
					Grid.SetColumn(InputControl, 0)
					Grid.SetRow(InputControl, 1)
					InputControl.RotateHorizontal()
				Case Else
			End Select
			MyBase.OnOrientationChanged(e)
		End Sub

		Private Sub NewGame_Click(ByVal sender As Object, ByVal e As EventArgs)
			MainBoard.GameBoard = GameBoardViewModel.LoadNewPuzzle()
		End Sub

		Private Sub Solve_Click(ByVal sender As Object, ByVal e As EventArgs)
			MainBoard.GameBoard.Solve()
		End Sub

		Private Sub Clear_Click(ByVal sender As Object, ByVal e As EventArgs)
			MainBoard.GameBoard.Clear()
		End Sub
	End Class
End Namespace
