﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports SudukoArticle.Utility

Namespace SudukoArticle.ViewModels
	Public Class SquareViewModel
		Inherits ViewModelBase
		#Region "Properties"
		Private _value As Integer
		Public Property Value() As Integer
			Get
				Return _value
			End Get
			Set(ByVal value As Integer)
				If IsEditable Then
					_value = value
					NotifyPropertyChanged("Value")
					NotifyPropertyChanged("StringValue")
					UpdateState()
				End If
			End Set
		End Property

		Public ReadOnly Property StringValue() As String
			Get
                Dim result = ""
				If _value > 0 Then
					result = _value.ToString()
				End If
				Return result
			End Get
		End Property

		Private _isSelected As Boolean = False
		Public Property IsSelected() As Boolean
			Get
				Return _isSelected
			End Get
			Set(ByVal value As Boolean)
				_isSelected = value
				UpdateState()
			End Set
		End Property

        Private _isValid As Boolean = True
		Public Property IsValid() As Boolean
			Get
				Return _isValid
			End Get
			Set(ByVal value As Boolean)
				_isValid = value
				UpdateState()
			End Set
		End Property

		Private _isEditable As Boolean = True
		Public Property IsEditable() As Boolean
			Get
				Return _isEditable
			End Get
			Set(ByVal value As Boolean)
				_isEditable = value
				UpdateState()
			End Set
        End Property

        Public Property Row() As Integer

        Public Property Column() As Integer

		Private _currentBoxState As Integer = BoxStates.Default
		Public Property CurrentBoxState() As Integer
			Get
				Return _currentBoxState
			End Get
			Set(ByVal value As Integer)
				_currentBoxState = value
				NotifyPropertyChanged("CurrentBoxState")
			End Set
		End Property
		#End Region

		Private Sub UpdateState()
			If IsEditable Then
				If IsSelected Then
					CurrentBoxState = BoxStates.Selected
				ElseIf Not IsValid Then
					CurrentBoxState = BoxStates.Invalid
				Else
					CurrentBoxState = BoxStates.Default
				End If
			Else
				CurrentBoxState = BoxStates.UnEditable
			End If
		End Sub
	End Class
End Namespace
