﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports SudukoArticle.ViewModels

Namespace SudukoArticle.Views
	Partial Public Class GameBoardView
		Inherits UserControl
		Public Sub New()
			InitializeComponent()
		End Sub

		Private _gameBoard As GameBoardViewModel
		Public Property GameBoard() As GameBoardViewModel
			Get
				Return _gameBoard
			End Get
			Set(ByVal value As GameBoardViewModel)
				_gameBoard = value
				BindBoard()
			End Set
		End Property

		#Region "Private Methods"
		Private Sub ChildBoxClicked(ByVal sender As Object, ByVal e As EventArgs)
			Dim inputSquare As SquareViewModel = CType((CType(sender, SquareView)).DataContext, SquareViewModel)
			If GameBoard.SelectedBox IsNot Nothing Then
				GameBoard.SelectedBox.IsSelected = False
			End If

			If GameBoard.SelectedBox Is inputSquare OrElse (Not inputSquare.IsEditable) Then
				GameBoard.SelectedBox = Nothing
			Else
				GameBoard.SelectedBox = inputSquare
				GameBoard.SelectedBox.IsSelected = True
			End If
		End Sub

		Private Sub BindBoard()
            For i = 0 To 8
                For j = 0 To 8
                    Dim square = GameBoard.GameArray(i, j)
                    Dim uiSquare As New SquareView(square)
                    LayoutRoot.Children.Add(uiSquare)
                    AddHandler uiSquare.BoxClicked, AddressOf ChildBoxClicked

                    Grid.SetRow(uiSquare, i)
                    Grid.SetColumn(uiSquare, j)

                    uiSquare.DataContext = square
                Next j
            Next i
		End Sub

		#End Region

	End Class
End Namespace
